routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/*Route::get('/', function () {
    return view('dashboard');
});*/

Auth::routes();


Route::middleware('auth')->group(function () {
    Route::get('/', 'HomeController@index')->name('dashboard');
    Route::get('userDetail/{id}', 'HomeController@userDetail')->name('userDetail');
    Route::get('userDetail/{user_id}/trip/{trip_id}', 'UserTripController@show')->name('user_trip_detail');
    Route::get('/logout', 'HomeController@logout');
    Route::get('/profile', function ()
    {
        return view('pages.user.profile');

    })->name('profile');

    Route::get('/change-password', function ()
    {
        return view('pages.user.change_password');

    })->name('change-password');
    Route::delete('attachment/{id}', 'Admin\GeneralSettingController@delete_attachment')->name('delete_attachment');
    Route::post('/profile', 'Admin\GeneralSettingController@updateProfile')->name('update-profile');
    Route::post('/change-password', 'Admin\GeneralSettingController@updatePassword')->name('update-change-password');

    Route::get('notifications', 'Admin\GeneralSettingController@index')->name('notification-all');
    Route::get('notifications/{id}', 'Admin\GeneralSettingController@show')->name('notification.show');
    Route::get('notifications/read/{id}', 'Admin\GeneralSettingController@edit')->name('notification.read');

    Route::resource('users', 'Admin\UserController');
    Route::put('users/status/{id}', 'Admin\UserController@updateStatus')->name('users.status');
    Route::get('driver/requests', 'Admin\DriverController@Driverrequests')->name('driver.requested');
    Route::get('driver/requests/{id}', 'Admin\DriverController@DriverrequestsUser')->name('driver.requested.id');
    Route::get('driver/accept/{id}', 'Admin\DriverController@DriverAccept')->name('driver.accept');
    Route::get('driver/reject/{id}', 'Admin\DriverController@DriverReject')->name('driver.reject');
    Route::resource('driver', 'Admin\DriverController');
    Route::resource('brands', 'Admin\CarBrandController');
    Route::resource('models', 'Admin\CarModelController');
    Route::resource('faqs', 'Admin\FaqsController');
    Route::resource('generalsetting', 'Admin\GeneralSettingController');
    Route::resource('appbanner', 'Admin\AppBannerController');
    Route::resource('promocodes', 'Admin\PromocodeController');
    Route::resource('user-trips', 'Admin\UserTripController');
    Route::resource('payments', 'Admin\PaymentController');
    Route::resource('user-complaints', 'Admin\ComplaintController');
    Route::resource('custom-notification', 'Admin\CustomEmailController');
    Route::resource('rental-cars', 'Admin\RentalCarController');
    Route::resource('booking-cars', 'Admin\BookedRentalCarController');
    Route::get('booking-cars/{status}/{id}', 'Admin\BookedRentalCarController@updateStatus');
    Route::get('booking-cars/status/{status}/{id}', 'Admin\BookedRentalCarController@updatebookingStatus');
    Route::put('banner/status/{id}', 'Admin\AppBannerController@updateStatus')->name('banner.status');
});

Route::get('storage/app/{dir}/{filename}', function ($dir, $filename) {
    $path = storage_path('app/' . $dir . '/' . $filename);
    /*
    if (!File::exists($path)) {
        abort(404);
    }

    $file = File::get($path);
    $type = File::mimeType($path);

    $response = Response::make($file, 200);
    $response->header("Content-Type", $type);
    */
    return response()->file($path);

});

use App\Models\User;
use App\Notifications\ChatMessage;

Route::get('/test/{email}', function ($email) {
    $receiver = User::where('email', $email)->first();
    $receiver->notify(new ChatMessage($receiver, 'Test notification'));
});

// use App\Events\LocateDriver;
// use DB;

// Route::get('/socket-test', function () {
//     $data = [
//         'user_id' => 11,
//         'latitude' => 12.45,
//         'longitude' => 12.45,
//     ];
//     event(new LocateDriver($data));
//     return "ok";
// });
// Route::get('/truncate', function () {
//     DB::statement("SET SQL_SAFE_UPDATES = 0;");
//     DB::table('users')->where('id','!=',382)->delete();
//     return "ok";
//     DB::table('user_addresses')->truncate();
//     DB::table('user_trips')->truncate();
//     DB::table('attachments')->truncate();
// });

app/Models/Promocode.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Promocode extends Model
{
    use HasFactory, SoftDeletes;
    protected $fillable = ['promocode', 'discount_type', 'discount_value', 'started_at', 'expired_at', 'status', 'title', 'description'];

    protected $casts = ['started_at' => 'datetime', 'expired_at' => 'datetime', 'discount_value' => 'float'];

    // public function users()
    // {
    //     return $this->hasManyThrough(User::class, PromocodeUser::class, 'user_id', 'id', 'id', 'id');
    // }
}

app/Http/Controllers/Admin/PromocodeController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Promocode;
use App\DataTables\PromocodesDataTable;
use App\Models\PromocodeUser;
use App\Rules\DiscountValidation;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Notification;
use App\Notifications\Promocode as PromocodeNotifications;
use Illuminate\Support\Facades\Log;
use App\Models\User;
use App\Jobs\SendPromoEmailQueue;
use Carbon\Carbon;
use Validator;

class PromocodeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(PromocodesDatatable $promocodeDatatable)
    {
        return $promocodeDatatable->render('pages.promocodes.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $users = User::where('type', 'USER')->get();

        return view('pages.promocodes.create', compact('users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        Validator::make($request->all(), [
            'promocode' => 'required|string|unique:promocodes,promocode',
            'discount_type' => 'required|in:fixed,percent',
            'discount_value' => ['required', new DiscountValidation($request->discount_type)],
            'started_at' => 'required|date|after_or_equal:today',
            'expired_at' => 'required|date|after:started_at',
        ])->validate();
            // dd($request->all());
        $promos = Promocode::create($request->all());
        $users = [];
        if(is_array($request->users))
        {
            if(in_array('all', $request->users))
            {
                PromocodeUser::create(['user_id' => NULL, 'promocode_id' => $promos->id]);
                $users = User::where('type', 'USER')->where('is_archive', 0)->get();
            }else
            {
                $users = User::whereIn('id', $request->users)->get();
                foreach($request->users as $user)
                {
                    PromocodeUser::create(['user_id' => $user, 'promocode_id' => $promos->id]);
                }
            }
        }else
        {
            $users = User::where('type', 'USER')->where('is_archive', 0)->get();
            PromocodeUser::create(['user_id' => NULL, 'promocode_id' => $promos->id]);
        }
        try
        {
            $mail = new SendPromoEmailQueue($promos, $users);
            $mail->delay(Carbon::now()->addSeconds(2));
            dispatch($mail);

        }catch(\Exception $e)
        {
            Log::debug("Email issue in Promocode Controller Store");
            Log::debug($e->getMessage());
        }
        Session::flash('success', 'Promocode Added Successfully');
        return redirect()->route('promocodes.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $promo = Promocode::find($id);

        return view('pages.promocodes.edit', compact('promo'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        Validator::make($request->all(), [
            'discount_value' => ['required', new DiscountValidation($request->discount_type)],
            'started_at' => 'required|date',
            'expired_at' => 'required|date|after:started_at',
        ])->validate();

        $promos = Promocode::find($id)->update($request->only('title', 'description', 'discount_value', 'started_at', 'expired_at', 'status'));
        if($request->has('users'))
        {
            $promos->users()->delete();
            if(is_array($request->users))
            {
                if(in_array('all', $request->users))
                {
                    PromocodeUser::create(['user_id' => NULL, 'promocode_id' => $promos->id]);
                }else
                {
                    foreach($request->users as $user)
                    {
                        PromocodeUser::create(['user_id' => $user, 'promocode_id' => $promos->id]);
                    }
                }
            }else
            {
                $users = User::where('type', 'USER')->where('is_archive', 0)->get();
                PromocodeUser::create(['user_id' => NULL, 'promocode_id' => $promos->id]);
            }
        }
        Session::flash('insert', 'Promo Updated Successfully');

        return redirect()->route('promocodes.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/pages/promocodes/create.blade.php
@extends('layouts.default')
@section('title', 'Add Promocodes')
@section('content')
    <div class="content-wrapper">
        <div class="row">
            <div class="col-12 grid-margin stretch-card">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title">Add Promocodes</h4>
                        <form class="forms-sample" action="{{route('promocodes.store')}}" method="POST" enctype="multipart/form-data">
                            @csrf
                            <div class="form-group">
                                <label for="title">Title</label>
                                <input type="text" class="form-control @error('title') is-invalid @enderror" value="{{old('title')}}" name="title" id="title" placeholder="Title">
                                @error('title')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="description">Description</label>
                                <textarea class="form-control @error('description') is-invalid @enderror" name="description" id="description" placeholder="Description">{!! old('description') !!}</textarea>
                                @error('description')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="promocode">Promocode</label>
                                <input type="text" class="form-control @error('promocode') is-invalid @enderror" value="{{old('promocode')}}" name="promocode" id="promocode" placeholder="Promocode">
                                @error('promocode')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="discount_type">Disscount Type</label>
                                <select name="discount_type" class="form-control @error('discount_type') is-invalid @enderror" id="discount_type">
                                    <option value="percent" @selected(old('discount_type') == 'percent')>Percent</option>
                                    <option value="fixed" @selected(old('discount_type') == 'fixed')>Fixed</option>
                                </select>
                                @error('discount_type')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="discount_value">Disscount Value</label>
                                <input type="number" class="form-control @error('discount_value') is-invalid @enderror" value="{{old('discount_value')}}" name="discount_value" id="discount_value" placeholder="Disscount Value">
                                @error('discount_value')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="users">Users</label>
                                <select id="users" name="users[]" class="form-control select2 @error('users') is-invalid @enderror" multiple>
                                    <option value="all" @selected(old('users', $promocode->user_id??'')=='all')>All Users</option>
                                    @foreach ($users as $user)
                                        <option value="{{ $user->id }}" @selected(old('users', $promocode->user_id??'')==$user->id)>{{ $user->first_name.' '.$user->last_name }}</option>
                                    @endforeach
                                </select>
                                @error('users')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="started_at">Started At</label>
                                <input type="datetime-local" class="form-control @error('started_at') is-invalid @enderror" value="{{old('started_at')}}" name="started_at" id="started_at" placeholder="Started At">
                                @error('started_at')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="expired_at">Expired At</label>
                                <input type="datetime-local" class="form-control @error('expired_at') is-invalid @enderror" value="{{old('expired_at')}}" name="expired_at" id="expired_at" placeholder="Expired At">
                                @error('expired_at')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>

                            <button type="submit" class="btn btn-primary me-2">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/pages/promocodes/datatable_action.blade.php
<a href="{{ route('promocodes.edit', $id) }}" class="btn btn-warning btn-xs">edit</a>
<form action="{{ route('promocodes.destroy', $id) }}">
    @method('DELETE')
    @csrf
    <button type="submit" class="btn btn-warning btn-xs"><i class="fa fa-trash"></i> Delete</button>
</form>

resources/views/pages/promocodes/edit.blade.php
@extends('layouts.default')
@section('title', 'Add Promocodes')
@section('content')
    <div class="content-wrapper">
        <div class="row">
            <div class="col-12 grid-margin stretch-card">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title">Add Promocodes</h4>
                        <form class="forms-sample" action="{{route('promocodes.update', $promo->id)}}" method="POST" enctype="multipart/form-data">
                            @csrf
                            @method('PUT')

                            <div class="form-group">
                                <label for="title">Title</label>
                                <input type="text" class="form-control @error('title') is-invalid @enderror" value="{{old('title', $promo->title)}}" name="title" id="title" placeholder="Title">
                                @error('title')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="description">Description</label>
                                <textarea class="form-control @error('description') is-invalid @enderror" name="description" id="description" placeholder="Description">
                                    {!! old('description', $promo->description) !!}
                                </textarea>
                                @error('description')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>

                            <div class="form-group">
                                <label for="promocode">Promocode</label>
                                <input type="hidden" value="{{old('promocode', $promo->promocode)}}" name="promocode" id="promocode" placeholder="Promocode" readonly>
                                <p>{{ $promo->promocode }}</p>
                                @error('promocode')
                                <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="discount_type">Disscount Type</label>
                                <input type="hidden" value="{{ $promo->discount_type }}" name="discount_type" />
                                <p>{{ $promo->discount_type }}</p>

                                @error('discount_type')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="discount_value">Disscount Value</label>
                                <input type="number" class="form-control @error('discount_value') is-invalid @enderror" value="{{old('discount_value', $promo->discount_value)}}" name="discount_value" id="discount_value" placeholder="Disscount Value">
                                @error('discount_value')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="started_at">Started At</label>
                                <input type="datetime-local" class="form-control @error('started_at') is-invalid @enderror" value="{{old('started_at', $promo->started_at)}}" name="started_at" id="started_at" placeholder="Started At">
                                @error('started_at')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label for="expired_at">Expired At</label>
                                <input type="datetime-local" class="form-control @error('expired_at') is-invalid @enderror" value="{{old('expired_at', $promo->expired_at)}}" name="expired_at" id="expired_at" placeholder="Expired At">
                                @error('expired_at')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>

                            <div class="form-group">
                                <input type="radio" value="active" @checked(old('status', $promo->status) == 'active') name="status" id="active" />
                                <label for="active">Active</label>

                                <input type="radio" value="inactive" @checked(old('status', $promo->status) == 'inactive') name="status" id="in-active" />
                                <label for="in-active">In-Active</label>

                                @error('status')
                                    <div class="alert alert-danger">{{ $message }}</div>
                                @enderror
                            </div>

                            <button type="submit" class="btn btn-primary me-2">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/pages/promocodes/index.blade.php
@extends('layouts.default')
@section('title', 'Promocode List')
@section('content')
<div class="content-wrapper">
    <div class="row">
      <div class="col-lg-12 grid-margin stretch-card">
        <div class="card">
          <div class="card-body">
            <h4 class="card-title">Promocode List</h4>
            <div class="table-responsive">
                {{ $dataTable->table() }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  @push('scripts')
    {{ $dataTable->scripts(attributes: ['type' => 'module']) }}
@endpush
@endsection